/**
 * Decoder interface.
 */

#pragma once

#include <xdc/std.h>
#include <ti/xdais/dm/ividdec2.h>

#include "AlgorithmUtils.h"
#include "Common.h"
#include "TranscodeComponent.h"

typedef struct Decoder {
    IVIDDEC2_Handle handle;
    IVIDDEC2_Fxns* functions;
    IVIDDEC2_InArgs* inArguments;
    IVIDDEC2_OutArgs* outArguments;
    IVIDDEC2_Status* status;
    IVIDDEC2_Params* params;
    IVIDDEC2_DynamicParams* dynamicParams;
    IALG_MemRec memTabs[MAX_MEM_RECS];
    TranscodeComponent* component;
    int32_t groupId;
    int isGroupMaster;

    void (*waitGroup)(struct Decoder* decoder);
    void (*syncAllSharedMemory)(struct Decoder* decoder);
    void (*activate)(struct Decoder* decoder);
    void (*deactivate)(struct Decoder* decoder);
    void (*delete)(struct Decoder* decoder);
} Decoder;
