/**
 * Common types for DSP and PC programs.
 */

#include <stdint.h>

#pragma once

#define CONFIGURATION_ADDRESS_ON_DSP (0x80000000)
#define CORES_PER_DSP                (8)

// Decoders
#define H264HP_DECODER (0)
#define DEFAULT_CONFIG_VALUE (-0xFFFF)

// Markers
#define INPUT_PACKET_MARKER  (0xAABBCCDD)
#define CONFIGURATION_MARKER (0xABBA)

typedef struct {
    int32_t coreIds[CORES_PER_DSP];
    int32_t decoderType;
    int32_t inputWidth;
    int32_t inputHeight;
    int32_t inputFrameRate;
    int32_t timeBaseNumerator;
    int32_t timeBaseDenominator;
    uint32_t inputBufferAddress;
    uint32_t inputBufferSize;
} DspDecoderConfiguration;

typedef struct {
    uint32_t marker;
    uint32_t decodersCount;
    DspDecoderConfiguration decoderConfigurations[64];
} DspConfiguration;
