#include <xdc/runtime/Memory.h>
#include <xdc/runtime/System.h>
#include <xdc/runtime/IHeap.h>
#include <xdc/cfg/global.h>

#include "Heaps.h"

IHeap_Handle ddr3Heap;
IHeap_Handle ddr3UncachedHeap;
IHeap_Handle msmcHeap;

void Heaps_printState()
{
    Memory_Stats stats;

    Memory_getStats(NULL, &stats);
    System_printf("L2    free %x of %x handle=%p\n", stats.totalFreeSize, stats.totalSize, l2Heap);

    Memory_getStats(ddr3Heap, &stats);
    System_printf("DDR3  free %x of %x handle=%p\n", stats.totalFreeSize, stats.totalSize, ddr3Heap);

    Memory_getStats(ddr3UncachedHeap, &stats);
    System_printf("DDR3U free %x of %x handle=%p\n", stats.totalFreeSize, stats.totalSize, ddr3UncachedHeap);

    Memory_getStats(msmcHeap, &stats);
    System_printf("MSMC  free %x of %x handle=%p\n", stats.totalFreeSize, stats.totalSize, msmcHeap);

    System_flush();
}
