/**
 * Multicore API for algorithms (i.e. decoders and encoders).
 */

#include <ti/xdais/xdas.h>

#include "TranscodeComponent.h"
#include "ividmc/ividmc3.h"

extern TranscodeComponent* MulticoreApi_transcodeComoponent;

inline void MulticoreApi_setActiveAlgorithm(TranscodeComponent* component)
{
    MulticoreApi_transcodeComoponent = component;
}

void MulticoreApi_useMsmcHeap(int enable);

// IVIDMC API

extern void MulticoreApi_swbarr(int32_t coreID, int32_t swbarr_id, uint32_t swbarr_cnt);
extern int32_t* MulticoreApi_shmmap(int32_t coreID, int32_t shmem_key, int32_t shmem_size, uint32_t attr, int32_t alignment);
extern int32_t MulticoreApi_shmmunmap(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);
extern int32_t MulticoreApi_shmmap_sync(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);

extern void MulticoreApi_swbarrDummy(int32_t coreID, int32_t swbarr_id, uint32_t swbarr_cnt);
extern int32_t* MulticoreApi_shmmapDummy(int32_t coreID, int32_t shmem_key, int32_t shmem_size, uint32_t attr, int32_t alignment);
extern int32_t MulticoreApi_shmmunmapDummy(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);
extern int32_t MulticoreApi_shmmap_syncDummy(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);
extern void MulticoreApi_syncAllSharedMemoryDummy();

// IVIDMC3 API

extern void* MulticoreApi3_keyCreate(uint8_t* name, int32_t user_id, IVIDMC3_KEY_SPACE_e key_space, int32_t num_users, int32_t* user_ids, IVIDMC3_KeyCfg_t* cfg);
extern int32_t MulticoreApi3_lockAcquireDummy(int32_t user_id, void* lockHandle);
extern int32_t MulticoreApi3_lockReleaseDummy(int32_t user_id, void* lockHandle);
extern int32_t MulticoreApi3_lockCheckDummy(int32_t user_id, void* lockHandle);
extern int32_t MulticoreApi3_barrWaitDummy(int32_t user_id, void* barrHandle);
